/*
 *  sample_bipartite_external_field.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_angle(int bonds, int term, double *alpha, int numalpha)
{
    // add your model specifique parameter here! 
	
    // BIPARTITE AFS: linear chain, sqare and cubic lattice cases 
	
    // Heisenberg AFs on bipartite lattices. 
    //  tdelta * H1 + H2 + H3 + ...

    double returnValue,j_dash;
	
    returnValue=0.0;
    j_dash=4.0;
	
    if (bonds == 3) {

      if (term_13[term]==1) returnValue=     -cos(2*alpha[0])*j_dash;
      if (term_13[term]==2) returnValue= -0.5*sin(2*alpha[0])*j_dash;
      if (term_13[term]==3) returnValue= -0.5*sin(2*alpha[0])*j_dash;
      if (term_13[term]==4) returnValue=  0.5*sin(2*alpha[0])*j_dash;
      if (term_13[term]==5) returnValue=  0.5*sin(2*alpha[0])*j_dash;
      if (term_13[term]==6) returnValue= 0.25*(1.0-cos(2*alpha[0]))*j_dash;
      if (term_13[term]==7) returnValue= 0.25*(1.0-cos(2*alpha[0]))*j_dash;
      if (term_13[term]==8) returnValue=-0.25*(1.0+cos(2*alpha[0]))*j_dash;
      if (term_13[term]==9) returnValue=-0.25*(1.0+cos(2*alpha[0]))*j_dash;
	  
    } else if (bonds == 2) {

      if (term_13[term]==1) returnValue=     -cos(2*alpha[0]);
      if (term_13[term]==2) returnValue= -0.5*sin(2*alpha[0]);
      if (term_13[term]==3) returnValue= -0.5*sin(2*alpha[0]);
      if (term_13[term]==4) returnValue=  0.5*sin(2*alpha[0]);
      if (term_13[term]==5) returnValue=  0.5*sin(2*alpha[0]);
      if (term_13[term]==6) returnValue= 0.25*(1.0-cos(2*alpha[0]));
      if (term_13[term]==7) returnValue= 0.25*(1.0-cos(2*alpha[0]));
      if (term_13[term]==8) returnValue=-0.25*(1.0+cos(2*alpha[0]));
      if (term_13[term]==9) returnValue=-0.25*(1.0+cos(2*alpha[0]));
//    returnValue=0.0;
	  
    } else if (bonds == 1) {
	  
      if (term_13[term]==10) returnValue=     sin(alpha[0]);
      if (term_13[term]==11) returnValue= 0.5*cos(alpha[0]);
      if (term_13[term]==13) returnValue= 0.5*cos(alpha[0]);

    } 
	
    return returnValue;
}

/*
 *  sample_bipartite_external_field.cppsample_bipartite_external_field_expectation
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_exp_angle(int expect, int term, double *alpha, int numalpha)
{
    // add your model specifique parameter here! 
	
    // BIPARTITE AFS: linear chain, sqare and cubic lattice cases 
	
    // Heisenberg AFs on bipartite lattices. 
    //  tdelta * H1 + H2 + H3 + ...

    double returnValue;
	
    returnValue=0.0;
	
    if (expect == 1) {
	  
      if (term_13[term]==10) returnValue=     sin(alpha[0]);
      if (term_13[term]==11) returnValue= 0.5*cos(alpha[0]);
      if (term_13[term]==13) returnValue= 0.5*cos(alpha[0]);

    } 
	
    return returnValue;
}
